/*********************************************************************
function:	error
description:	Error message routines
programmer:	Alan S. Watt

history:
	11/04/81	original version
	07/17/82	fixes for lint
	08/10/82	modest cleanup before posting.
*********************************************************************/

#ifndef lint
 static char Sccsid[] = "@(#)error.c	1.1";
#endif !lint

#include <stdio.h>
#define NOTOK	(-1)

/* VARARGS1 */
error (mesg, args)
char *mesg;
{
	_doprnt (mesg, &args, stderr);
	putc ('\n', stderr);
	exit (NOTOK);
}

extern	errno;
extern	sys_nerr;
extern	char *sys_errlist[];
#ifdef lint
 int	errno;
 int	sys_nerr;
 char *sys_errlist[1];
#endif lint
static	char ehuh[]	= "Unknown System Error";

/* VARARGS1 */
fperror (mesg, args)
char *mesg;
{
	char *err = ((unsigned)errno >= sys_nerr ? ehuh : sys_errlist[errno]);

	_doprnt (mesg, &args, stderr);
	fprintf (stderr, ": %s\n", err);
	exit (NOTOK);
}

/*VARARGS1*/
remark (mesg, args)
char *mesg;
{
	_doprnt (mesg, &args, stderr);
	putc ('\n',stderr);
}

/*VARARGS1*/
fpremark (mesg, args)
char *mesg;
{
	char *err = ((unsigned)errno >= sys_nerr ? ehuh : sys_errlist[errno]);

	_doprnt (mesg, &args, stderr);
	fprintf (stderr, ":%s\n", err);
}
