.\"From titcca!titcce!mohta Tue Apr 14 14:13:27 JST 1987
.\"Article 213 of fj.sources:
.\"Path: icot!titcca!titcce!mohta
.\">From: mohta@titcce.cc.titech.JUNET (Masataka Ohta)
.\"Newsgroups: fj.sources
.\"Subject: texpr online manual (In English)
.\"Keywords: tex, manual
.\"Message-ID: <448@titcce.cc.titech.JUNET>
.\"Date: 14 Apr 87 03:15:35 GMT
.\"Distribution: fj
.\"Organization: Tokyo Institute of Technology, JAPAN
.\"Lines: 127
.\"
.\"The following lines are roff version manual of texpr. They can be placed
.\"in appropriate section of "/usr/man" directory and can be used as an
.\"on-line manual or be output to lbp through troff (seems to be meaning-
.\"less). They are modification of original 'man.tex' contained in original
.\"distribution of texpr system by 'mohta@titcce.cc.titech.junet'.
.\"					Masataka Ohta

.\"
.\"	Copyright (c) Japan TeX Users Group, 1986 1987
.\"
.TH TEXPR 1 "10 April 1987"
.SH NAME
texpr \- print out dvi-file to LBP-8
.SH SYNOPSIS
.B texpr
[\ \fIoptions\fR\ ] \fIdvi-file\fR
.SH DESCRIPTION
.IX "texpr command" "" "\fLtexpr\fP \(em print tex dvi files"
.IX "print tex dvi files" texpr "" "\fLtexpr\fP \(em print tex dvi files"
.IX file print "" "print tex dvi \(em \fLtexpr\fP"
Texpr is a program which converts the dvi file to a sequence 
of LBP-8 commands and sends them to the printer.
Texpr spools dvi file like lpr.
Logical device name to which texpr outputs is
.I lp
(site dependent).
Extension 
.B .dvi
can be omitted in the file specification.
.SH OPTIONS
.LP
.IP \fB\-p\fI\ n1\fP[,\fIn2\fP[,\fIn3\fP]] 1i
Print from
.I n1
page to
.I n2
page. And
.I n3
is a even-odd specifier.
You can specify 2 or 1 or 0 for
.I n3.
Each value means even page,
odd page, both page respectively. (Default is 0.)
Some examples are shown below.
.RS
.IP \fB\-p\ 5\fP 1i
from 5 page to end page
.IP \fB\-p\ 5,10\fP
5, ..., 10 page
.IP \fB\-p\ 5,11,1\fP
5,7,9,11 page
.IP \fB\-p\ 1,1\fP
1 page only
.IP \fB\-p\ 5,,2\fP
6,8,10,12,...,end page
.RE
.IP \fB\-r\fP
Print in reverse order of page. (As you know, LBP-8 stacks paper
in face up manner.)
.IP \fB\-t\ \fR[\(+-]\fIn\fP
Move top margin position \fIn\fP/100
inch down from default position.
Move up if negative. For example,
.RS
.IP \fB\-t\ 50\fP 1i
move top margin position 1/2 inch down
.RE
.IP \fB\-l\ \fR[\(+-]\fIn\fP
Move left margin position \fIn\fP/100
inch right from default position.
Move left if negative. For example,
.RS
.IP \fB\-l\ \-25\fP 1i
move left margin position 1/4 inch left
.RE
.IP
(When you use manual paper feed, you had better specify
.B \-t 20 \-l \-10
to correct registration position.)
.IP \fB\-d\fP
Force down load. Usually texpr searchs for the most frequently used font,
and then checks whether the same font name is written in .down_font
file. Texpr does font loading only if not same. But this option force
down loading even if same. (You should use this option after printer power
on.)
.IP \fB\-m\fIx\fP
Use this magnification value instead of one in the dvi file.
Following 7 formats are available.
.RS
.IP \fB\-m0\fP 1i
\(mu 1 magnification
.IP \fB\-mh\fP
\(mu sqrt(1.2) magnification
.IP \fB\-m1\fP
\(mu 1.2 magnification
.IP \fB\-m2\fP
\(mu 1.2**2 magnification
.IP \fB\-m3\fP
\(mu 1.2**3 magnification
.IP \fB\-m4\fP
\(mu 1.2**4 magnification
.IP \fB\-m5\fP
\(mu 1.2**5 magnification
.RE
.IP \fB\-c\ \fIn\fP
Specify number of copies.
.IP \fB\-v\fP
Verbose mode. Various messages are output to your terminal.
.IP \fB\-h\fP
Use paper with long side horizontal.
(CAUTION! This option is for only AJ2 model, and rather slow.)
.\" Added option in titech
.\" .IP \fB\-P\fIprinter\fP
.\" Force output to the named
.\" .I printer.
.\" Normally, the
.\" default printer is used (site dependent), or the value
.\" of the TEXPRINTER or PRINTER environment variable is used.
.SH FILES
.nf
.ta \w'/usr/lib/tex/fonts/.down_font         'u
/usr/local/lib/lbpd.lbp8	daemon-filter for lbp8
/usr/lib/tex/fonts/*.*pxl	font file
/usr/lib/tex/fonts/*.*pk	new format font file
/usr/lib/tex/fonts/.down_font	memo file
.fi
.SH "SEE ALSO"
tex(1)
