/*	$@%U%)%s%H$N%@%&%s%m!<%I(J		*/

#include <stdio.h>
#include "def.h"
#define	F_NUM		14		/* $@EPO?%U%)%s%H?t(J		*/
#define	CSIZE(l)	((((l) >> 3)*(l))+2)	/* $@%U%)%s%H$NBg$-$5(J	*/
#define	MINCODE		0x21		/* $@%3!<%I$N:G>.CM(J		*/
#define	MAXCODE		0x7e		/* $@%3!<%I$N:GBgCM(J		*/
#define CPFSET		(MAXCODE-MINCODE+1)	/* $@%U%)%s%HCf$N:GBgJ8;z?t(J */
#define	FIRSTFNUM	200		/* $@:G=i$N%U%)%s%H%;%C%H$NHV9f(J	*/
#define max(x,y)	(((x) > (y)) ? (x) : (y))

int	chr_num[F_NUM];	/*	$@#2#4(J $@!A(J $@#1#2#8(J step 8			*/
int	b[F_NUM];	/*	$@4p=`0LCV(J				*/
int	l[F_NUM];	/*	$@4p=`0J2<$ND9$5(J				*/
int	h[F_NUM];	/*	$@A4BN$ND9$5(J				*/
int	cfont = FIRSTFNUM;	/*	$@8=:_$N%U%)%s%HHV9f(J		*/

compnum(p1,p2)
C_ENTRY	*p1,*p2;
{
	if (p1->usenum > p2->usenum) return (-1);
	if (p1->usenum < p2->usenum) return (1);
	return (0);
}

fontload()
{
	int	fnum;
	int	fno;
	char	*new();
	int	compnum();
	int	i;
	FONTINF	*fop;
	int	ch_size;
	long	mem_avail;

	/*	$@;HMQ%U%)%s%H$NFI$_=P$7(J	*/
	
	r_fonts();

	/*	$@;HMQIQEY=g$K%=!<%H$9$k(J	*/

	qsort(chrtbl,c_pnt,sizeof(C_ENTRY),compnum);
	for (i = 0; i < F_NUM; i++) chr_num[i] = b[i] = l[i] = h[i] = 0;
	for (mem_avail = prn->down_area, i = 0; i < c_pnt; i++) {
		fop = chrtbl[i].fntptr;
		ch_size = max(fop->width,fop->height);
		ch_size = (ch_size <= 24) ? 24 : ((ch_size+7) & ~7);
		if (chk_size(ch_size,fop->height,fop->yoffset,&mem_avail)) {
			fop->flag &= ~RASTER;
			fop->flag |= DOWNLOAD;
			fop->chinf.conv_code.real_fnt = ch_size >> 3;
		}
	}

	/*	$@%@%&%s%m!<%I(J	*/

	for (i = 0; i < F_NUM; i++) {
		if (chr_num[i]) d_fonts(i);
	}

	/*	$@%@%&%s%m!<%I$G$-$J$+$C$?J8;z$NB0@-$r(JRASTER$@$KJQ$($k(J	*/

	for (i = 0; i < c_pnt; i++) {
		fop = chrtbl[i].fntptr;
		if (!(fop->flag & DOWNLOAD)) continue;
		if (fop->chinf.conv_code.real_fnt < FIRSTFNUM) {
			fop->flag &= ~DOWNLOAD;
			fop->flag |= RASTER;
		}
	}
}

/*	$@4p=`0LCV!$4p=`0J2<$ND9$5!$%U%)%s%H$NBg$-$5$N8!::(J	*/
chk_size(size,height,offset,mem)
int	size,height,offset;
long	*mem;
{
	int	f;
	int	tb,tl;

	if (*mem <= 0) return (0);
	if (size > prn->maxsize) return (0);
	if (*mem < CSIZE(size)) {
		if (size == 24) *mem = 0;
		return (0);
	}
	f = (size >> 3)-3;
	chr_num[f]++;
	*mem -= CSIZE(size);
	tb = max(b[f],offset);
	tl = max(l[f],height-offset);
	if (tb+tl <= size) {
		b[f] = tb;
		l[f] = tl;
		h[f] = max(tb+tl,h[f]);
	} else {
		h[f] = max(height,h[f]);
	}
	return (1);
}

/*	$@%U%)%s%H$N%$%a!<%8%G!<%?$NFI$_=P$7(J	*/
r_fonts()
{
	FILE	*pkf;
	DVIFONT	*dvp;
	int	f_num,i;
	int	xmag5;
	char	pkfile[MAXBUF],*pkname;

#ifdef notdef
	init_kanji();
#endif
	for (f_num = 0; f_num < f_pnt; f_num++) {
		dvp = dvifonts[f_num];
#ifdef notdef
		if (chk_kanji(dvp)) continue;
#endif
		xmag5 = dvp->mag/5;		/*	for PK size	*/
		pkname = dvp->fname;
		/* search currently opened font file */
		pkf = NULL;
		for (i = 0; i < p_pnt; i++) {
			sprintf(pkfile,"%s/%s.%dpk",f_path[i],pkname,xmag5);
			if ((pkf = fopen(pkfile,READ)) != NULL) break;
			sprintf(pkfile,"%s/%s.%dpk",f_path[i],pkname,xmag5-1);
			if ((pkf = fopen(pkfile,READ)) != NULL) break;
			sprintf(pkfile,"%s/%s.%dpk",f_path[i],pkname,xmag5+1);
			if ((pkf = fopen(pkfile,READ)) != NULL) break;
		}
		if (pkf == NULL) error("no pkfile=%s\n",pkfile);
		loadpk(pkf,dvp);
		fclose(pkf);
	}
}

/*	$@%U%)%s%H$N%@%&%s%m!<%I(J	*/

d_fonts(n)
int	n;
{
	FONTINF	*fop;
	int	chr, chn, code;
	int	fnt,wl,hl,bl;

	wl = n+3; hl = h[n]; bl = b[n]; fnt = 3+n; chn = chr_num[n];
	chr = 0;
	while (chn) {
		int	cchn;

		if (cfont > 255) return;
		cchn = (chn < CPFSET) ? chn : CPFSET;
		chn -= cchn;
#if USE7
		fputs("\033[",Out);
#else
		fputs("\233",Out);
#endif
		fprintf(Out,"%ld;%d;",(long)(wl*hl+4)*cchn,cchn);
		fprintf(Out,"0;0;%d;2;%d;%d;",DG0_n,prn->pmag,DF_HIGT);
		fprintf(Out,"%d;%d;%d;",CHRSTYL,CHRSTLK,cfont);
		fprintf(Out,"%d;%d;%d;0",wl*8,hl,hl-bl);
#if USE7
		fputs("/p",Out);
#else
		fputs(".p",Out);
#endif
		for (code = MINCODE; chr < c_pnt; chr++) {
			char	*cp;
			int	l1,l2,l3;
			int	oy,cy,cw;

			fop = chrtbl[chr].fntptr;
			if (!(fop->flag & DOWNLOAD)) continue;
			if (fop->chinf.conv_code.real_fnt != fnt) continue;
			fop->chinf.conv_code.real_fnt = cfont;
			cp = fop->raster;
			if (fop->raster == NULL) {
				l1 = hl;
				l2 = l3 = fop->yoffset = 0;
			} else {
				oy = fop->yoffset;
				cy = fop->height;
				cw = (fop->width+7) >> 3;
				l1 = ((bl >= oy) && ((hl-bl) >= (cy-oy)))
						? (bl-oy) : 0;
				l2 = cy; l3 = hl-l1-l2;
				fop->yoffset -= (bl-l1);
			}
			put_code(code);
			fop->TFMC = (fop->TFMwidth+RSUper2PXL)/RSUperPXL;
			if (fop->TFMC < 0) fop->TFMC = 0;
			else if (fop->TFMC >= 128) fop->TFMC = 127;
			put_code(fop->TFMC);
			put_code(fop->width);
			if (fop->xoffset <= -prn->maxsize) {
				put_code(prn->maxsize-1);
				fop->xoffset += prn->maxsize-1;
			} else if (fop->xoffset >= prn->maxsize) {
				put_code(-prn->maxsize+1);
				fop->xoffset -= prn->maxsize-1;
			} else {
				put_code(-fop->xoffset);
				fop->xoffset = 0;
			}
			for (l1 *= wl; l1--;) put_code(0);
			while (l2--) {
				int	i;

				for (i = 0; i < cw; i++) put_code(*cp++);
				while (i++ < wl) put_code(0);
			}
			for (l3 *= wl; l3--;) put_code(0);
			fop->chinf.conv_code.code_num = code++;
			if (--cchn <= 0) break;
		}
		cfont++;
	}
}

