/*	$@%Q%9#1(J		*/

#include <stdio.h>
#include "def.h"

skip_char(n)
int	n;
{
	while (n--) getc(In);
}

pass1_skip()
{
	int	dvicmd,xchar;
	long	lop;
	long	getuint();

	while(1) {
		dvicmd = getc(In);
		if (dvicmd >= 0 && dvicmd <= 127) continue;
		if (dvicmd >= 171 && dvicmd <= 234) continue;
		switch(dvicmd){
		case NOP:	case PUSH:	case POP:	case W0:
		case X0:	case Y0:	case Z0:
			break;
		case SET1:	case PUT1:	case RIGHT1:	case W1:
		case X1:	case DOWN1:	case Y1:	case Z1:
		case FNT1:
			skip_char(1);
			break;
		case SET2:	case PUT2:	case RIGHT2:	case W2:
		case X2:	case DOWN2:	case Y2:	case Z2:
		case FNT2:
			skip_char(2);
			break;
		case SET3:	case PUT3:	case RIGHT3:	case W3:
		case X3:	case DOWN3:	case Y3:	case Z3:
		case FNT3:
			skip_char(3);
			break;
		case SET4:	case PUT4:	case RIGHT4:	case W4:
		case X4:	case DOWN4:	case Y4:	case Z4:
		case FNT4:
			skip_char(4);
			break;
		case SET_RULE:	case PUT_RULE:
			skip_char(8);
			break;
		case EOP:
			return;
		case XXX1:	case XXX2:	case XXX3:	case XXX4:
			lop = getuint(In,dvicmd-XXX1);
			while(lop--) getc(In);
			break;
		case FNT_DEF1:	case FNT_DEF2:	case FNT_DEF3:	case FNT_DEF4:
			xchar = getuint(In,dvicmd-FNT_DEF1+1);
			fontreg(xchar);
			break;
		case POST:
		default:
			error("%x: illegal dvicmd\n",dvicmd);
		}
	}
}

/*	$@Cf4V%U%!%$%k$X$N=PNO(J	*/

puttmp(n,l)
long	n;
int	l;
{
	switch(l) {
	case 4 : putc((int)(n >> 24) & 0xff,tmpf);
	case 3 : putc((int)(n >> 16) & 0xff,tmpf);
	case 2 : putc((int)(n >> 8) & 0xff,tmpf);
	case 1 : putc((int)n & 0xff,tmpf);
	}
}


pass1_page()
{
	int	dvicmd,xchar;
	long	t1,getuint(),getint();

	current = NULL;
	t1 = ftell(tmpf); putc(BOP,tmpf); puttmp(b_pos,4); b_pos = t1;
	while(1) {
		dvicmd = getc(In);
		if (dvicmd >= 0 && dvicmd <= 127) {	/* character */
			putc(dvicmd,tmpf);
			use_char(dvicmd);
			continue;
		}
		if (dvicmd >= 171 && dvicmd <= 234) {	/* font */
			putc(dvicmd,tmpf);
			fontsrch(dvicmd-171);
			continue;
		}
		switch(dvicmd){
		case SET1:	case SET2:	case SET3:	case SET4:
			xchar = getuint(In,dvicmd-SET1+1);
			putc(dvicmd,tmpf);
			puttmp(xchar,dvicmd-SET1+1);
			use_char(xchar);
			break;
		case SET_RULE:
			putc(dvicmd,tmpf);
			puttmp(getint(In,4),4);
			puttmp(getuint(In,4),4);
			break;
		case PUT1:	case PUT2:	case PUT3:	case PUT4:
			xchar = getuint(In,dvicmd-PUT1+1);
			putc(dvicmd,tmpf);
			puttmp(xchar,dvicmd-PUT1+1);
			use_char(xchar);
			break;
		case PUT_RULE:
			putc(dvicmd,tmpf);
			puttmp(getint(In,4),4); 
			puttmp(getuint(In,4),4);
			break;
		case NOP:
			break;
		case EOP:
			putc(dvicmd,tmpf);
			return;
		case PUSH:
			putc(dvicmd,tmpf);
			break;
		case POP:
			putc(dvicmd,tmpf);
			break;
		case RIGHT1:	case RIGHT2:	case RIGHT3:	case RIGHT4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-RIGHT1+1),dvicmd-RIGHT1+1);
			break;
		case W0:
			putc(dvicmd,tmpf);
			break;
		case W1:	case W2:	case W3:	case W4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-W1+1),dvicmd-W1+1);
			break;
		case X0:
			putc(dvicmd,tmpf);
			break;
		case X1:	case X2:	case X3:	case X4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-X1+1),dvicmd-X1+1);
			break;
		case DOWN1:	case DOWN2:	case DOWN3:	case DOWN4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-DOWN1+1),dvicmd-DOWN1+1);
			break;
		case Y0:
			putc(dvicmd,tmpf);
			break;
		case Y1:	case Y2:	case Y3:	case Y4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-Y1+1),dvicmd-Y1+1);
			break;
		case Z0:
			putc(dvicmd,tmpf);
			break;
		case Z1:	case Z2:	case Z3:	case Z4:
			putc(dvicmd,tmpf);
			puttmp(getuint(In,dvicmd-Z1+1),dvicmd-Z1+1);
			break;
		case FNT1:	case FNT2:	case FNT3:	case FNT4:
			xchar = getuint(In,dvicmd-FNT1+1);
			putc(dvicmd,tmpf);
			puttmp(xchar,dvicmd-FNT1+1);
			fontsrch(xchar);
			break;
		case XXX1:	case XXX2:	case XXX3:	case XXX4:
			t1 = getuint(In,dvicmd-XXX1);
			while (t1--) getuint(In,1);
			break;
		case FNT_DEF1:	case FNT_DEF2:	case FNT_DEF3:	case FNT_DEF4:
			xchar = getuint(In,dvicmd-FNT_DEF1+1); fontreg(xchar);
			break;
		case POST:
		default:
			error("%x: illegal dvicmd\n",dvicmd);
		}
	}
}
