#include <stdio.h>
#include "def.h"

#define round(x)	(((x)+RSUper2PXL)/RSUperPXL)
#define sp2rsu(x)	((long)((Magnif*0.001)*dviinfm.RSU*x))
#define getrsu(x)	sp2rsu(getint(tmpf,x))
#define	Font(chr)	(current->fonts[chr])

putpage()
{
	int	dvicmd,svvp,svhp,hp,vp,xchar;
	long	t1,t2;
	FRAM	fstack[MAXSTACK];
	FRAM	ftmp;
	int	stpint;

/* left margin */
	if (lmargin > 0) cxhrz_r(lmargin); else cxhrz_l(-lmargin);
/* top margin */
	if (tmargin > 0) cxvrt_d(tmargin); else cxvrt_u(-tmargin);
/* cg set */
	stpint = svvp = svhp = hp = vp = ftmp.hpos = ftmp.vpos =
	ftmp.xamt = ftmp.wamt = ftmp.yamt = ftmp.zamt = 0;
	current = NULL;
	while(1) {
		dvicmd = getc(tmpf);
		if (dvicmd >= 0 && dvicmd <= 127) {	/* character */
			hp = round(ftmp.hpos); vp = round(ftmp.vpos);
			printchar(dvicmd,&svhp,&svvp,hp,vp);
			ftmp.hpos += Font(dvicmd).TFMwidth;
			continue;
		}
		if (dvicmd >= 171 && dvicmd <= 234) {	/* font */
			fontsrch(dvicmd-171);
			continue;
		}
		switch(dvicmd) {
		case SET1:	case SET2:	case SET3:	case SET4:
			xchar = getuint(tmpf,dvicmd-SET1+1);
			hp = round(ftmp.hpos); vp = round(ftmp.vpos);
			printchar(xchar,&svhp,&svvp,hp,vp);
			ftmp.hpos += Font(xchar).TFMwidth;
			break;
		case SET_RULE:
			{
				int	h,v,higl,widl;

				t1 = getint(tmpf,4); t2 = getint(tmpf,4);
				if (t1 > 0 && t2 > 0) {
					h = round(ftmp.hpos);
					v = round(ftmp.vpos);
					t2 = sp2rsu(t2);
					ftmp.hpos += t2;
					higl = round(sp2rsu(t1));
					widl = round(t2);
					printline(v,h,higl,widl,&svvp,&svhp);
				} else {
					ftmp.hpos += sp2rsu(t2);
				}
			}
			break;
		case PUT1:	case PUT2:	case PUT3:	case PUT4:
			xchar = getuint(tmpf,dvicmd-PUT1+1);
			hp = round(ftmp.hpos); vp = round(ftmp.vpos);
			printchar(xchar,&svhp,&svvp,hp,vp);
			break;
		case PUT_RULE:
			{
				int	h,v,higl,widl;

				t1 = getint(tmpf,4); t2 = getint(tmpf,4);
				if (t1 > 0 && t2 > 0) {
					h = round(ftmp.hpos);
					v = round(ftmp.vpos);
					higl = round(sp2rsu(t1));
					widl = round(sp2rsu(t2));
					printline(v,h,higl,widl,&svvp,&svhp);
				}
			}
			break;
		case EOP:
			return;
		case PUSH:
			if (stpint > MAXSTACK-1) error("stack overflow \n");
			fstack[stpint++] = ftmp;
			break;
		case POP:
			if (stpint <= 0) error("stack underflow\n");
			ftmp = fstack[--stpint];
			break;
		case RIGHT1:	case RIGHT2:	case RIGHT3:	case RIGHT4:
			ftmp.hpos += getrsu(dvicmd-RIGHT1+1);
			break;
		case W1:	case W2:	case W3:	case W4:
			ftmp.wamt = getrsu(dvicmd-W1+1);
		case W0:
			ftmp.hpos += ftmp.wamt;
			break;
		case X1:	case X2:	case X3:	case X4:
			ftmp.xamt = getrsu(dvicmd-X1+1);
		case X0:
			ftmp.hpos += ftmp.xamt;
			break;
		case DOWN1:	case DOWN2:	case DOWN3:	case DOWN4:
			ftmp.vpos += getrsu(dvicmd-DOWN1+1);
			break;
		case Y1:	case Y2:	case Y3:	case Y4:
			ftmp.yamt = getrsu(dvicmd-Y1+1);
		case Y0:
			ftmp.vpos += ftmp.yamt;
			break;
		case Z1:	case Z2:	case Z3:	case Z4:
			ftmp.zamt = getrsu(dvicmd-Z1+1);
		case Z0:
			ftmp.vpos += ftmp.zamt;
			break;
		case FNT1:	case FNT2:	case FNT3:	case FNT4:
			xchar = getuint(tmpf,dvicmd-FNT1+1);
			fontsrch(xchar);
			break;
		default:
			error("%x: illegal dvicmd\n",dvicmd);
		}
	}
}
