#define sibling left
#define child right \

#define is_last(S)(S->sibling==NULL) \

/*1:*/
#line 20 "jtreeprint.web"

/*12:*/
#line 137 "jtreeprint.web"

#define svert '|'
#define shoriz '-'
#define scross '+'
#define scorner '\\' 

#define pvert '|'
#define phoriz '-'
#define pcross '+'
#define pcorner '\\' 

/*:12*/
#line 21 "jtreeprint.web"

/*5:*/
#line 67 "jtreeprint.web"
#include<stdio.h>

/*:5*/
#line 22 "jtreeprint.web"

/*2:*/
#line 44 "jtreeprint.web"

typedef struct tnode{
struct tnode*left,*right;
char*data;
}TNODE;
/*:2*//*10:*/
#line 127 "jtreeprint.web"
char*malloc();

/*:10*//*13:*/
#line 149 "jtreeprint.web"

char vert= svert;
char horiz= shoriz;
char cross= scross;
char corner= scorner;

/*:13*//*15:*/
#line 178 "jtreeprint.web"

char indent_string[100]= "";

/*:15*/
#line 23 "jtreeprint.web"



main(argc,argv)
int argc;
char**argv;
{
/*3:*/
#line 49 "jtreeprint.web"

struct tnode*root;

/*:3*/
#line 30 "jtreeprint.web"
;
/*14:*/
#line 156 "jtreeprint.web"

while(--argc>0){
if(**++argv=='-'){
switch(*++(*argv)){
case'p':
vert= pvert;
horiz= phoriz;
cross= pcross;
corner= pcorner;
break;
default:
fprintf(stderr,"treeprint: bad option -%c\n",**argv);
break;
}
}
}

/*:14*/
#line 31 "jtreeprint.web"
;
/*11:*/
#line 130 "jtreeprint.web"
read_tree(stdin,&root);

/*:11*/
#line 32 "jtreeprint.web"
;
/*18:*/
#line 235 "jtreeprint.web"
print_node(stdout,indent_string,root);

/*:18*/
#line 33 "jtreeprint.web"

exit(0);
}

/*:1*//*4:*/
#line 55 "jtreeprint.web"

read_tree(fp,rootptr)
FILE*fp;
struct tnode**rootptr;
{
char buf[255],*p;

while((fgets(buf,255,fp))!=NULL){
/*6:*/
#line 70 "jtreeprint.web"

p= buf;while(*p!='\0'&&*p!='\n')p++;

*p= '\0';

/*:6*/
#line 63 "jtreeprint.web"
;
add_tree(rootptr,buf);
}
}
/*:4*//*7:*/
#line 78 "jtreeprint.web"

add_tree(rootptr,p)
struct tnode**rootptr;
char*p;
{
char*s;
int slashed;

if(*p=='\0')return;

/*8:*/
#line 113 "jtreeprint.web"

for(s= p;*s!='\0'&&*s!='/';)s++;
if(*s=='/'){
slashed= 1;
*s= '\0';
}else slashed= 0;

/*:8*/
#line 90 "jtreeprint.web"
;

if(*rootptr==NULL){
/*9:*/
#line 121 "jtreeprint.web"

*rootptr= (struct tnode*)malloc(sizeof(struct tnode));
(*rootptr)->left= (*rootptr)->right= NULL;
(*rootptr)->data= malloc(strlen(p)+1);

/*:9*/
#line 93 "jtreeprint.web"
;
strcpy((*rootptr)->data,p);
}
if(strcmp((*rootptr)->data,p)==0){
if(slashed)++s;
add_tree(&((*rootptr)->child),s);
}
else{
if(slashed)*s= '/';
add_tree(&((*rootptr)->sibling),p);
}
}

/*:7*//*16:*/
#line 187 "jtreeprint.web"

print_node(fp,indent_string,node)
FILE*fp;
char*indent_string;
struct tnode*node;
{
char string[255];
int i;
char*p,*is;

if(node==NULL){
}
else{
*string= '\0';
for(i= strlen(indent_string);i>0;i--)
strcat(string," |  ");
strcat(string," +--");
/*17:*/
#line 223 "jtreeprint.web"

is= indent_string;
for(p= string;*p!='\0';p++)switch(*p){
case'|':*p= *is++;break;
case'+':*p= (is_last(node)?corner:cross);break;
case'-':*p= horiz;break;
default:break;
}


/*:17*/
#line 204 "jtreeprint.web"
;
fprintf(fp,"%s%s\n",string,node->data);



*is++= (is_last(node)?' ':vert);
*is=='\0';

print_node(fp,indent_string,node->child);
*--is= '\0';
print_node(fp,indent_string,node->sibling);
}

}
/*:16*/
