/**********************************************************************/
/************************  Global Definitions  ************************/
/**********************************************************************/
/* $Header$ */

typedef int BOOLEAN;
#define NEW(A) ((A *) malloc(sizeof(A)))
#define DEBUG   1			/* for massive printing of input */
					/* trace information; select by -d */
					/* option after filename: */
					/* dvibit filename -d */

#define BINARYOPEN fopen		/* byte-oriented host version */

#define ARITHRSHIFT 1                   /* define if ">>" operator is a
                                           sign-propagating arithmetic
                                           right shift */
#define USEGLOBALMAG 1			/* when defined, the dvi global
   					   magnification is applied */

#define FALSE           0
#define TRUE            1
#define NO_FILE         NULL
#define NONEXISTANT     -1   /* offset for PXL files not found */              
#define	DVIFORMAT	2
#define	FIRSTPXLCHAR	0
#define  HALFPXLCHAR    127
#define  LASTPXLCHAR    255
#define  LASTFNTCHAR    255
#define  NHALFPXLCHARS  128
#define  NPXLCHARS      256
#define	DOWNLOADFIRST	0x21
#define	DOWNLOADLAST	0x7e
#define	FONTAREA	"/usr/lib/tex/fonts"
#define	PXLID		1001
#define	RESOLUTION	300
#define	STACKSIZE	100
#define	STRSIZE		257
#define	BUFSIZE		4096
#define	GFXSETBASE	1001
#define	GFXSETMAX      65535
#define	MAXOPEN      	45

#define FT_PXL		1
#define FT_PK		0

#define	fix(x)		(int)((x) + 0.5)

struct openfont_list
{
    FILE *openfont_file_id;     /* file identifier                          */
    int use_count;              /* count of "opens"                         */
    int last_use;
};
