/*
 * impress.h
 *
 * header file for finding data bases having to do with the imprint printer
 * by Bill Nowicki, Stanford University, September 1981
 */

# define PixelsPerInch 300		/* Resolution of the printer being used */

  /*
   * size of printable area, 8x10.5 inches
   */
# define PixelsPageHeight ( (int)( PixelsPerInch*10.5 )	)
# define PixelsPageWidth ( PixelsPerInch*8 )

  /*
   * memory parameters
   */
# define K 1024
/*# define GlyphSize (164*K) */	/* size of printer's Glyph buffer */
# define GlyphSize 653312	/* changed for our IMAGEN 8/300 and 3320 */
/*# define InputSize (24*K) */	/* size of printer's input buffer */
# define InputSize (72*K) /* doubled by yaski to avoid "Input area overflow" */
# define GlyphsPerPage (10*K)	/* number of distinct glyphs per page */

