char *malloc();

char *rotate (glyph, ht, wd) char *glyph; int ht, wd;
{
    int		byteswide;
    int		oldwidth;
    int		byteoff, bitmask, outbitoff, outbit, posn, i;
    char	*opt, *outptr;
    
    if (ht == 0 || wd == 0) return (glyph);
    byteswide = (ht+7)/8;
    oldwidth = (wd+7)/8;

    opt = malloc (1 + byteswide*wd);
    outptr = opt; *outptr = '\0';
    
    for (posn = 0; posn < wd; posn++)	/* Pick the nth bit off each row */
    {
	bitmask = 1 << (7 - (posn%8) );
	byteoff = posn/8;
	outbitoff = 7;
	for (i = 0; i < ht ; i++)	/* Get from each row... */
	{
	    if (outbitoff < 0) {
		outbitoff = 7;
		outptr++; *outptr = '\0';
	    }
	    outbit =(*(glyph + ((ht-i)-1)*oldwidth + byteoff) & bitmask) != 0;
	    *outptr |= outbit << outbitoff;
	    outbitoff--;
    	}
	outptr++; *outptr = '\0';
    }
    return (opt);
}
