/*
 $Header: kyocera.c,v 1.3 88/12/08 02:16:22 root Locked $

     lbp tab and mergin set routine

     options
	-s size		char/inch (6/10/12/15)
	-x offset_x	left mergin
	-y offset_y	forward mergin
	-t 		transpose ( we have no font now )

      change vertical space	Mon Dec  8 20:32:55 GMT+9:00 1986

      change to filter mode
      lbpflt [ -c ] -wwidth -llength -iindent -n  login  -h  host acct-file

*/

#include <stdio.h>

int	skip = 0;
int	x = 5;
int	y = 2;
int	vmi;
int	transpose = 0;

main(ac,av) 
int ac;
char **av;
{
    register int c;
    int i,l,p,o;

    p = 6;
    vmi = 10;
    while(ac--) 
	if (ac>0 && (++av)[0][0]=='-') 
	   switch(av[0][1]) {
	   case 'x': /* This is offset not pxl */
		x = atoi(++av[0]); break;
	   case 'y': /* This is offset not pxl */
		y = atoi(++av[0]); break;
	   case 't':
		transpose = 1; break;
	   case 'v':       /* vmi */
		vmi = atoi((++av)[0]); --ac; break;
	   case 'c':
		skip = 1;
		break;
	   case 'i': 
		transpose = atoi(av[0]+2)?1:0;
		break;
	   case 'l':
		break;
	   case 'n': case 'h': ++av; --ac;
		break;
	   case 'w': 	  /* size */
		i = atoi(av[0]+2);   /* add "-w" */
		if (i==0) i = 6;
		goto set_size;
	   case 's': 	  /* size */
		av++;
		i = atoi(av++[0]);
		ac--;
set_size:	p = i;
		break;
	    default: 
	      fprintf(stderr,"parameter error -%c\n",o);
	      exit(2);
/*		fprintf(stderr,
    "aux lbptab [-s size -x offset_x -y offset_y -t -v vmi ]");
		exit(0); */
	    }

    if (!skip) {
	printf("!R! res; spm p; ftmd 15; unit c;");
	if (transpose)
	    printf("slm 0.5;spo l;");
	else
	    printf("slm 1.2;spo p;"); 
	/* font set */
	printf("setf 1,%d;",p);
	printf("altf 1;exit;\n");
    }

    if (skip)
	while ( (c = getchar())!=EOF ) putchar(c);
    else
	while ( (c = getchar())!=EOF ) 
	    if (c=='\n') {
		putchar(c);
		putchar('\015');
	    } else
		putchar(c);

    printf("!R! res; exit;");   
    fflush(stdout); 

    sleep(10); /* wait for flush network */
    exit(0);
}

