/*
.nf
*/
#include <stdio.h>

/* support tool for lbp graphic

    parameter format
      x-data bit, s-sign bit

    01xxxxxx|01xxxxxx|.....|001sxxxx
*/

p(i)
int i;
{
    register unsigned int p,b,c;
    int j;

    j = i>0 ? i : -i;
    if (j>=16) {
	for (b=30,p=0x40000000 ; !(p&j) ; b--) p >>= 1;
	for(b = 1 << ((b-4)%6), c=0x40 ; p>8 ; b >>= 1,p >>= 1) {
	    if (p&j) 
		c += b;
	    if (b==1) {
		if ((c & 0x3f) == 0x3f) c--;
		putchar(c);
		b = c = 0x40;	/* on data */
	    }
	}
	j &= 0xf;
    }
    j += i>=0 ? 0x30 : 0x20;		/* end of data */
    putchar(j);
}

cs(s)
char *s;
{
    fputs("\033[",stdout);
    fputs(s,stdout);
}

htoi(c)
char c;
{

   switch(c) {
	case '0': return 0;
	case '1': return 1;
	case '2': return 2;
	case '3': return 3;
	case '4': return 4;
	case '5': return 5;
	case '6': return 6;
	case '7': return 7;
	case '8': return 8;
	case '9': return 9;
	case 'a': return 10;
	case 'b': return 11;
	case 'c': return 12;
	case 'd': return 13;
	case 'e': return 14;
	case 'f': return 15;
   }
}

hex(s)
char *s;
{
    int i;

    while(*s)
	if (*s != ' ' && *s != '\t') {
	    i = htoi(*s++) * 16;
	    i += htoi(*s++);
	    putchar(i);
	} else
	    s++;
}

scale(factor,m)
    int factor,m;
{
    putchar('!');
    putchar('0');
    p(m);
    p(factor);
    putchar('\36');
}

origin(x,y)
    int x,y;
{
    putchar('\175');
    putchar('\"');
    p(x);
    p(y);
    putchar('\36');
}

