/*	$@#D#V#I#2#L#B#P$G;HMQ$9$k%5%V%k!<%A%s(J	*/

#include <stdio.h>
#include "def.h"

/*	$@2DJQD9@0?t$N<hF@!JId9fL5$7!K(J	*/

long getuint(fp,n)
FILE	*fp;
int	n;
{
	long	d = 0;

	switch (n) {
	case 4 : d = getc(fp);
	case 3 : d = (d << 8) | getc(fp);
	case 2 : d = (d << 8) | getc(fp);
	case 1 : d = (d << 8) | getc(fp);
	}
	return(d);
}

/*	$@2DJQD9@0?t$N<hF@!JId9fM-$j!K(J	*/

long getint(fp,n)
FILE	*fp;
int	n;
{
	register long	d = 0;

	d = getc(fp);
	if (d > 127) d -= 256 ;
	switch (n) {
	case 4 : d = (d << 8) | getc(fp);
	case 3 : d = (d << 8) | getc(fp);
	case 2 : d = (d << 8) | getc(fp);
	}
	return(d);
}

/*	$@%$%a!<%8%G!<%?$rAw$k(J	*/
put_code(code)
int		code;
{
#if USE7
	char	*hexch = "0123456789ABCDEF";

	putc(hexch[(code >> 4) & 15],Out);
	putc(hexch[code & 15],Out);
#else
	putc(code,Out);
#endif
}

/*	$@%U%)%s%H$NEPO?(J		*/

fontreg(fnum)
int	fnum;	/* $@EPO?%U%)%s%H$NHV9f(J		*/
{
	DVIFONT	*dvp;
	long	tmp;
	int	i,j;
	float	fnt_mag;
	char	*q;

	if (f_pnt >= MAXTEXFONT)
		error("%x: overflow max registable font number\n",fnum);
	dvp = (DVIFONT *)new(sizeof(DVIFONT));
	dvifonts[f_pnt++] = dvp;
	dvp->fnt_num = fnum;

/* get font size	*/
	getint(In,4);
	tmp = getuint(In,4);
	fnt_mag = (float)tmp/(float)(getuint(In,4));
	dvp->mag = ((float)dviinfm.mag*fnt_mag*(float)Magnif + 500)/1000.0;

/* get font name	*/	
	j = getc(In);	/* pixels directory name length */
	i = getc(In);	/* pixels  file name length */
/* discard directory name */
	while (j--) getc(In);
/* read file name */
	dvp->fname = q = new(i+1);
	while (i--) *q++ = getc(In);
	*q = EOS;
	for (i = 0; i < CHRTBL; i++) {
		dvp->fonts[i].flag = 0;
		dvp->fonts[i].chinf.tblptr = 0;
	}
}

/*	$@%U%)%s%H$N8!:w(J		*/

fontsrch(fnum)
int	fnum;	/* $@A*Br$9$k%U%)%s%HHV9f(J		*/
{
	int	lop;

	for (lop = 0; lop < f_pnt; lop++) {
		if (dvifonts[lop]->fnt_num == fnum) {
			current = dvifonts[lop];
			return;
		}
	}
	error("%d: not defined font number\n",fnum);
}

/*	$@;HMQJ8;z?t$N7WB,(J	*/

use_char(code)
int	code;
{
	FONTINF	*fop;

	if (current == NULL) error("no font used\n");
	fop = current->fonts+code;
	fop->flag |= USEFONT | RASTER;	/* set dafault mode	*/
	if (!(fop->flag & USEMAP)) {
		if ((fop->chinf.tblptr)++ < BOUND) return;
		if (c_pnt >= MAXCHAR) return;
		fop->flag |= USEMAP;
		chrtbl[c_pnt].fntptr = fop;
		chrtbl[c_pnt].usenum = fop->chinf.tblptr;
		fop->chinf.tblptr = c_pnt++;
		return;
	}
	(chrtbl[fop->chinf.tblptr].usenum)++;
}

/*	$@J8;z$N=PNO(J	*/

printchar(chr,px,py,lx,ly)
int	chr;		/*	$@#D#V#I%U%!%$%k>e$NJ8;z%3!<%I(J	*/
int	*px,*py;	/*	$@%W%j%s%?>e$N0LCV(J		*/
int	lx,ly;		/*	$@O@M}%W%j%s%?$N0LCV(J		*/
{
	FONTINF	*fop;	/*	$@J8;z>pJs$X$N%]%$%s%?(J		*/

	fop = current->fonts+chr;
	if (!(fop->flag & (DOWNLOAD | RASTER))) return;
	lx -= fop->xoffset;
	movehp(lx,*px);
	*px = lx+fop->TFMC;
	ly -= fop->yoffset;
	movevp(ly,*py);
	*py = ly;
	if (fop->flag & DOWNLOAD) {
		int	cx_font = fop->chinf.conv_code.real_fnt;
		int	code = fop->chinf.conv_code.code_num;

		if (cx_font != nowcxfont) {
			cxfont(cx_font);
			nowcxfont = cx_font;
		}
		putc(code,Out);
		return;
	}
	if (fop->flag & RASTER) {
		char	*temp;
		int	x,y;

		x = (fop->width+7) >> 3; y = fop->height;
		if (x*y == 0) return;
		temp = fop->raster;
		if (temp != NULL) {
#if USE7
			fprintf(Out,"\033[%d;%d;/r",x*y,x);
#else
			fprintf(Out,"\233%d;%d;.r",x*y,x);
#endif
			for (x *= y; x--; temp++) put_code(*temp);
		}
		return;
	}
	error("%s:%x  how to select font ?\n",current->fname,chr);
}

/*	$@6k7A$NIA2h(J	*/

printline(ypos,xpos,hig,wid,svp,shp)
int	ypos,xpos,hig,wid,*svp,*shp;
{
	--hig; --wid;
	movehp(xpos,*shp); *shp = xpos;
	movevp(ypos,*svp); *svp = ypos;
	cxsave;
	cxline_s;
	if (wid > 0) movehp(wid,0);
	if (hig > 0) movevp(-hig,0);
	cxline_e;
	cxrest;
}


/*	$@#n#o#w$+$i#m#v$N0LCV$^$GAjBP0\F0!J?eJ?J}8~!K(J	*/

movehp(mv,now)
int	mv,now;
{
	int	wk = mv-now;

	if (wk == 0) return;
	if (wk > 0) cxhrz_r(wk);
	else if (wk < 0) cxhrz_l(-wk);
}

/*	$@#n#o#w$+$i#m#v$N0LCV$^$GAjBP0\F0!J?bD>J}8~!K(J	*/

movevp(mv,now)
int	mv,now;
{
	int	wk = mv-now;

	if (wk == 0) return;
	if (wk > 0) cxvrt_d(wk);
	else if (wk < 0) cxvrt_u(-wk);
}
