/*	$@#P#K%U%)%s%H%U%!%$%k$X$N%"%/%;%9(J	*/

#include <stdio.h>
#include "def.h"

#define	min(x,y)	(((x) < (y)) ? (x) : (y))

/*	$@05=L7A<0$N%T%/%;%k%U%!%$%k$+$i%G!<%?$r<h$j=P$9(J	*/
/* $@#p#k%U%!%$%k$N%3%^%s%I(J	*/

#define PK_ID		89
#define PK_FLAG		239
#define PK_XXX1		240
#define PK_XXX2		241
#define PK_XXX3		242
#define PK_XXX4		243
#define PK_YYY		244
#define PK_POST		245
#define PK_NO_OP	246
#define PK_PRE		247

/*	$@J8;zNs$+$i?t;z$r<h$j=P$9(J	*/

static FILE	*pkf;		/* $@#P#K%U%!%$%k(J		*/
static int	sw;
static int	buf1;
static char	pat[8] = {0xff, 0x7f, 0x3f, 0x1f, 0x0f, 0x07, 0x03, 0x01};

#define	gnyb	(((sw ^= 1) ? ((buf1 = getc(pkf)) >> 4) : buf1) & 0xf)

/*	get run_count/repeat_count	*/

get_run(rn,rp,b)
int	*rn,*rp,b;
{
	int	i,r;

	for( ; ; ) {
		if ((i = gnyb) >= 14) {
			*rp = i*2-29;
			continue;
		}
		if (i > b)
			r = (i-b-1)*16+gnyb+b+1;
		else if (i > 0) r = i;
		else {
			do { ++i; } while ((r = gnyb) == 0);
			while (--i >= 0) r = r*16 + gnyb;
			r += (13-b)*16+b-15;
		}
		if (*rp >= 0) { *rn = r; return; }
		*rp = r;
	}
}

/*	$@%U%)%s%H$N%G%3!<%I(J	*/

char *decode(fp,x,y,cmd,work)
FILE	*fp;
int	x,y,cmd;
char	*work;
{
	int	dyn_f,bw,bx;
	char	*p,*q;

	pkf = fp;
	dyn_f = (cmd & 0xff)/16; bw = (cmd & 8) >> 3;
	bx = ((x+7) >> 3);
	{
		int	i;

		for (p = work, i = bx*y; i > 0; i--) *p++ = 0;
	}
	p = q = work;
	if (dyn_f == 14) {
		int	n,m,t,h,v;

		for(n = 0, v=0; v < y; v++) {
			for(h = 0; h < x; h += m) {
				if (n == 0) {
					t = (getc(pkf) & 0xff);
					n = 8;
				}
				m = min(n,8-(h & 7)); m = min(m, x-h);
				p[h/8] |= t >> (h & 7);
				t <<= m; n -= m;
			}
			if (x & 7) p[x/8] &= ~pat[x & 7];
			p += bx;
		}
	} else {
		int	run,rep,h,h1,v;

		sw = 0; bw ^= 1; run = 0;
		for(v = 0; v < y; v += (rep+1)) {
			rep = 0;
			for(h = 0; h < x; h = h1) {
				if(run == 0) {
					get_run(&run,&rep,dyn_f);
					bw ^= 1;
				}
				h1 = min(h+run, x);
				if(bw) {
					h1 = min(h1,(h+8) & ~7);
					p[h/8] |= pat[h & 7];
					if (h1 & 7) p[h1/8] &= ~pat[h1 & 7];
				}
				run -= h1-h;
			}
			q = p;	p += bx;
			for (h = rep*bx; --h >= 0; ) *p++ = *q++;
		}
	}
	return (work);
}

/*	$@%U%)%s%H$N<h$j=P$7(J	*/

loadpk(fp,dvp)
FILE	*fp;		/* $@%U%)%s%H%U%!%$%k(J			*/
DVIFONT	*dvp;		/* $@%U%)%s%HI=$X$N%]%$%s%?(J		*/
{
	long	fptr;
	int	cmd,c,i;
	long	d_size;
	float	scall;

	fseek(fp,0,LAST); fptr = ftell(fp);
	while (fptr > 0) {
		fseek(fp,--fptr,TOP);
		if ((c = getc(fp)) != PK_NO_OP) break;
	}
	if (fptr <= 0) error("seek error : %s\n",dvp->fname);
	fseek(fp,0,TOP);
	if (c != PK_POST || getc(fp) != PK_PRE || getc(fp) != PK_ID)
		error("bad pk file : %s\n",dvp->fname);
	fseek(fp,getc(fp),1);		/* comment */
	d_size = getint(fp,4); fseek(fp,12l,1);
	scall = ((float)d_size/FIXperREAL)* RSUperPOINT;
	scall *= (dvp->mag*0.001/FIXperREAL);
	for( ; ; ) {
		switch(cmd = getuint(fp,1)) {

		case PK_XXX1: case PK_XXX2: case PK_XXX3: case PK_XXX4:
			fseek(fp,getuint(fp,cmd-PK_XXX1+1),REL);
			continue;

		case PK_YYY:
			getint(fp,4);
			continue;

		case PK_NO_OP:
			continue;

		case PK_POST:
			return;

		default:
		{
			FONTINF	*fop;
			int	pl;
			long	TFM;
			int	n;
			int	fn;
			char	*new();

			if (cmd > PK_FLAG)
				error("illegal pk command %d\n", cmd);
			n = cmd & 7;
			if (n == 7) {		/* long form */
				pl = getuint(fp,4);
				fn = getuint(fp,4);
				n = 4;
			} else if (n >= 4) {	/* extended short */
				pl = (n-4)*65536l+getuint(fp,2);
				fn = getuint(fp,1);
				n = 2;
			} else {		/* short form */
				pl = n*256+getuint(fp,1);
				fn = getuint(fp,1);
				n = 1;
			}
			if (fn >= CHRTBL)
				error("exceed character number\n");
			fop = dvp->fonts+fn;
			if ((fop->flag & USEFONT) == 0) {
				fseek(fp,(long)pl,1);
				break;
			}
			if (n == 4) {
				TFM = getuint(fp,4);
				getint(fp,4);
			} else {
				TFM = getuint(fp,3);
			}
			getuint(fp,n);	/* skip dy/dm	*/
			fop->TFMwidth = scall*TFM;
			fop->width = getuint(fp,n);
			fop->height = getuint(fp,n);
			fop->xoffset = getint(fp,n);
			fop->yoffset = getint(fp,n);
			fop->raster =
				decode(fp,fop->width,fop->height,cmd,
				    new(((fop->width+7) >> 3)*(fop->height)));
			fop->TFMC = 0;
		}
		break;
		}
	}
}
