static char rcsid[] = "$Header: font.c,v 0.1 88/12/08 11:49:28 onuma Exp $";
/*
 * Copyright(C) $BF|K\EE5$3t<02q<R(J  $B>.>B(J $B@i3((J, 1989
 */

#include <stdio.h>
#include <newsiop/lbp.h>
#include "font_types.h"
#include "font.h"

float ratio();

int
font_def(font_no, check_sum, size, design_size, dirname, filename, mag)
int font_no;	/* $B%U%)%s%HHV9f(J */
int check_sum;	/* $B%A%'%C%/%5%`(J */
int size, design_size;	/* $B%5%$%:(J ($BC10L(J: sp) */
char *dirname, *filename;	/* $B%G%#%l%/%H%j(J/$B%U%!%$%kL>(J */
float mag;	/* magnification */
{
    struct font *fp;

    /* font_no $B%A%'%C%/(J */ 
    if (font_no < 0 || font_no >= MAX_FONT) {
	fprintf(stderr, "Illegal font No. %d\n", font_no);
	return(-1);
    }

    fp = &font[font_no];
    /* $B%U%)%s%HDj5A(J */
    if (j_font_def(fp, size, design_size, filename, mag) == -1 &&
#ifdef PXL_FORMAT
	pxl_font_def(fp, check_sum, size, design_size, dirname, filename, mag) == -1) {
#else
# ifdef PK_FORMAT
	pk_font_def(fp, check_sum, size, design_size, dirname, filename, mag) == -1) {
# else
	font format is not defined.
# endif
#endif
	    fprintf(stderr, "Unknown font: %s\n", filename);
	    fp->type = -1;
	    return(-1);
	}
    return(0);
}

int
set_char(font_no, x, y, code)
int font_no;	/* $B%U%)%s%HHV9f(J */
int x, y;	/* $B=PNO0LCV(J ($BC10L(J: dot) */
int code;	/* $B%3!<%I(J */
{
    struct font *fp;

    /* font_no $B%A%'%C%/(J */ 
    if (font_no < 0 || font_no >= MAX_FONT) {
	fprintf(stderr, "Illegal font No. %d\n", font_no);
	return(-1);
    }

    fp = &font[font_no];
    switch (fp->type) {
    case MINCHO:
    case GOTHIC:
	return(j_set_char(fp, x, y, code));
    case PXL:
    case PK:
	return(pxl_set_char(fp, x, y, code));
    case -1:
	return(0);	/* Unknown font */
    default:
	fprintf(stderr, "Illegal font type %d\n", fp->type);
    }
    return(0);
}

	
